#include <def21262.h>

.section/pm seg_rth;
	nop;nop;nop;nop;
	nop;jump start;
	
.section/dm seg_dmda;
	.var adc_data;
	
.section/pm seg_spi;
	jump spi_rx;nop;nop;nop;
	
.section/pm seg_pmco;
start:
	// Enabling interrupts
	bit set mode1 IRPTEN;
	bit set imask SPIHI;
		
	// Clear the registers first
	r0 = 0x0;
	dm(SPICTL) = r0;
	dm(SPIFLG)  = r0;
	dm(SPIBAUD) = r0;

	// Enabling Flag 0 as slave select.
	r0 = DS0EN;
	dm(SPIFLG) = r0;

	// Configuring the SPICLK - 5KHz
	r0 = 0x682;
	dm(SPIBAUD) = r0;

	// Setting the SPI for TIMOD - 00 mode. 
	// Transfer would be initiated by a dummy read of receive buffer
	r0 = WL16 | MSBF | CLKPL | SPIMS | SPIEN;
	dm(SPICTL) = r0;
	
	// Do a dummy read so that DSP generates SPICLK and CS for the A/D
	// converter to convert and start transferring the data
	r0 = dm(RXSPI) ;
		
	nop;
	nop;
	
	jump(pc,0);
	
// SPI ISR
spi_rx:
	r0 = dm(RXSPI);
	// For a 12 bit A/D converter (AD7276) last two bits are first
	r0 = lshift r0 by -2;
	dm(adc_data) = r0;
	rti;
