#include <def21262.h>

#define SIZE 100

.section/pm seg_rth;
	nop;nop;nop;nop;
	nop;jump start;
	
.section/dm seg_dmda;
	.var adc_data[SIZE];
	
.section/pm seg_spi;
	jump spi_rx;nop;nop;nop;
	
.section/pm seg_pmco;
start:
	// Setting the PLL multiplier to 6
	ustat1 = 0x8006;
	dm(PMCTL) = ustat1;
	
	// Wait for around 4096 cycles for the pll to lock
	lcntr = 5000, do (pc,1) until lce;
		nop;
		
	ustat1 = dm(PMCTL);
	bit clr ustat1 0x8000;
	dm(PMCTL) = ustat1;

	// Enabling interrupts
	bit set mode1 IRPTEN;
	bit set imask SPIHI;
		
	// Clear the registers first
	r0 = 0x0;
	dm(SPICTL) = r0;
	dm(SPIFLG)  = r0;
	dm(SPIBAUD) = r0;

	// Enabling Flag 0 as slave select.
	r0 = DS0EN;
	dm(SPIFLG) = r0;

	// DMA Parameters
	r0 = adc_data;
	dm(IISPI) = r0;
	
	r0 = 1;
	dm(IMSPI) = r0;
	
	r0 = SIZE;
	dm(CSPI) = r0;
	
	// Configuring the SPICLK - 12.5 MHz
	r0 = 0x5;
	dm(SPIBAUD) = r0;

	// Setting the SPI for TIMOD - 10 mode. 
	// Enable DMA transfer mode.
	r0 = TIMOD2 | WL16 | MSBF | CLKPL | SPIMS | SPIEN;
	dm(SPICTL) = r0;
	
	r0 = SPIDEN | SPIRCV | INTEN;
	dm(SPIDMAC) = r0;

	nop;
	nop;
	
	jump(pc,0);
	
// SPI ISR
spi_rx:
	// Performing the power down for ADC
	// This can be done by making a dummy read with SPI configured for
	// 8-bit word length. When CS is deasserted before 10th falling edge 
	// of SPICLK, ADC would go into power down mode
	r0 = 0x0;
	dm(SPICTL) = r0;
	dm(SPIFLG)  = r0;
	dm(SPIBAUD) = r0;
	
	// Enabling Flag 0 as slave select.
	r0 = DS0EN;
	dm(SPIFLG) = r0;

	// Configuring the SPICLK - 12.5 MHz
	r0 = 0x5;
	dm(SPIBAUD) = r0;

	// Dummy write to power down ADC
	r0 = 0xAA;
	dm(TXSPI) = r0;
	
	// Setting the SPI for TIMOD - 01 mode. 
	r0 = TIMOD1 | WL8 | MSBF | CLKPL | SPIMS | SPIEN;
	dm(SPICTL) = r0;
	
	// Disable the interrupts
	bit clr imask SPIHI;
	
	// Getting the 12-bit data from the 16-bit received words from ADC
	i0 = adc_data;
	m0 = 1;
	
	lcntr = SIZE, do right_shift until lce;
		r0 = dm(i0,m0);
		r0 = lshift r0 by -2;
right_shift: dm(-1,i0) = r0;	

	rti;
