#include <def21262.h>

.section/pm seg_rth;
	nop;nop;nop;nop;
	nop;jump start;
	
.section/dm seg_dmda;
	.var adc_data;
	
.section/pm seg_spi;
	jump spi_rx;nop;nop;nop;
	
.section/pm seg_pmco;
start:
	// Setting the PLL multiplier to 6
	ustat1 = 0x8006;
	dm(PMCTL) = ustat1;
	
	// Wait for around 4096 cycles for the pll to lock
	lcntr = 5000, do (pc,1) until lce;
		nop;
		
	ustat1 = dm(PMCTL);
	bit clr ustat1 0x8000;
	dm(PMCTL) = ustat1;

	// Enabling interrupts
	bit set mode1 IRPTEN;
	bit set imask SPIHI;
		
	// Clear the registers first
	r0 = 0x0;
	dm(SPICTL) = r0;
	dm(SPIFLG)  = r0;
	dm(SPIBAUD) = r0;

	// Enabling Flag 0 as slave select.
	r0 = DS0EN | SPIFLG0;
	dm(SPIFLG) = r0;

	// Configuring the SPICLK - 12.5MHz
	r0 = 0x4;
	dm(SPIBAUD) = r0;
	
	// Configuring TIMOD - 00 mode
	// Initiate transfer by reading from receive buffer
	r0 = WL16 | MSBF | CPHASE | CLKPL | SPIMS | SPIEN;
	dm(SPICTL) = r0;
	
	r0 = 0xAAAA;
	dm(RXSPI) = r0;
	
	nop;
	nop;
	jump(pc,0);
	
// SPI ISR
spi_rx:
	// Setting the flag 0 high
	r0 = DS0EN | SPIFLG0;
	dm(SPIFLG) = r0;
	
	// Delay 
	lcntr = 100, do (pc,1) until lce;
		nop;
		
	// Clearing Flag0.
	r0 = DS0EN;
	dm(SPIFLG) = r0;

	r0 = dm(RXSPI);
	// Shifting the 16-bit received word from ADC to get 12-bit data
	// In this mode with CPHASE = 1 and CLKPL = 1, though the ADC sends 
	// two leading zeros only the second zero is sampled by the DSP.
	r0 = lshift r0 by -3;
	dm(adc_data) = r0;
	
	rti;
